Index: trunk/LMDZ.GENERIC/libf/phystd/physiq.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1470)
+++ trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1477)
@@ -1031,37 +977,34 @@
          zflubid(1:ngrid)=fluxrad(1:ngrid)+fluxgrd(1:ngrid)
 
-         zdum1(1:ngrid,1:nlayer)=0.0
-         zdum2(1:ngrid,1:nlayer)=0.0
-
-
-!JL12 the following if test is temporarily there to allow us to compare the old vdifc with turbdiff	 
+         ! JL12 the following if test is temporarily there to allow us to compare the old vdifc with turbdiff.
 	 if (UseTurbDiff) then
 	 
-           call turbdiff(ngrid,nlayer,nq,rnat,       &
-              ptimestep,capcal,lwrite,               &
-              pplay,pplev,zzlay,zzlev,z0,            &
-              pu,pv,pt,zpopsk,pq,tsurf,emis,qsurf,   &
-              zdum1,zdum2,pdt,pdq,zflubid,           &
-              zdudif,zdvdif,zdtdif,zdtsdif,          &
-	      sensibFlux,q2,zdqdif,zdqevap,zdqsdif,  &
-              taux,tauy,lastcall)
+            call turbdiff(ngrid,nlayer,nq,rnat,                  &
+                          ptimestep,capcal,lwrite,               &
+                          pplay,pplev,zzlay,zzlev,z0,            &
+                          pu,pv,pt,zpopsk,pq,tsurf,emis,qsurf,   &
+                          pdt,pdq,zflubid,                       &
+                          zdudif,zdvdif,zdtdif,zdtsdif,          &
+	                  sensibFlux,q2,zdqdif,zdqevap,zdqsdif,  &
+                          taux,tauy,lastcall)
 
 	 else
 	 
-           zdh(1:ngrid,1:nlayer)=pdt(1:ngrid,1:nlayer)/zpopsk(1:ngrid,1:nlayer)
+            zdh(1:ngrid,1:nlayer)=pdt(1:ngrid,1:nlayer)/zpopsk(1:ngrid,1:nlayer)
  
-           call vdifc(ngrid,nlayer,nq,rnat,zpopsk,   &
-              ptimestep,capcal,lwrite,               &
-              pplay,pplev,zzlay,zzlev,z0,            &
-              pu,pv,zh,pq,tsurf,emis,qsurf,          &
-              zdum1,zdum2,zdh,pdq,zflubid,           &
-              zdudif,zdvdif,zdhdif,zdtsdif,          &
-	      sensibFlux,q2,zdqdif,zdqsdif,          &
-              taux,tauy,lastcall)
-
-           zdtdif(1:ngrid,1:nlayer)=zdhdif(1:ngrid,1:nlayer)*zpopsk(1:ngrid,1:nlayer) ! for diagnostic only
-	   zdqevap(1:ngrid,1:nlayer)=0.
-
-         end if !turbdiff
+            call vdifc(ngrid,nlayer,nq,rnat,zpopsk,           &
+                       ptimestep,capcal,lwrite,               &
+                       pplay,pplev,zzlay,zzlev,z0,            &
+                       pu,pv,zh,pq,tsurf,emis,qsurf,          &
+                       zdh,pdq,zflubid,                       &
+                       zdudif,zdvdif,zdhdif,zdtsdif,          &
+	               sensibFlux,q2,zdqdif,zdqsdif,          &
+                       taux,tauy,lastcall)
+
+            zdtdif(1:ngrid,1:nlayer)=zdhdif(1:ngrid,1:nlayer)*zpopsk(1:ngrid,1:nlayer) ! for diagnostic only
+	    zdqevap(1:ngrid,1:nlayer)=0.
+
+         end if !end of 'UseTurbDiff'
+
 
          pdv(1:ngrid,1:nlayer)=pdv(1:ngrid,1:nlayer)+zdvdif(1:ngrid,1:nlayer)
@@ -1070,8 +1013,8 @@
          zdtsurf(1:ngrid)=zdtsurf(1:ngrid)+zdtsdif(1:ngrid)
 
+
          if(ok_slab_ocean)then
             flux_sens_lat(1:ngrid)=(zdtsdif(1:ngrid)*capcal(1:ngrid)-fluxrad(1:ngrid))
          endif
-
 
 
@@ -1081,7 +1024,9 @@
          end if ! of if (tracer)
 
+
+         ! test energy conservation
          !-------------------------
-         ! test energy conservation
          if(enertest)then
+         
 	    dEzdiff(:,:)=cpp*mass(:,:)*zdtdif(:,:)
             do ig = 1, ngrid
@@ -1089,32 +1034,35 @@
 	       dEzdiff(ig,1)= dEzdiff(ig,1)+ sensibFlux(ig)! subtract flux to the ground
             enddo
+            
 	    call planetwide_sumval(dEdiff(:)*area(:)/totarea_planet,dEtot)
 	    dEdiffs(:)=capcal(:)*zdtsdif(:)-zflubid(:)-sensibFlux(:)
 	    call planetwide_sumval(dEdiffs(:)*area(:)/totarea_planet,dEtots)
 	    call planetwide_sumval(sensibFlux(:)*area(:)/totarea_planet,AtmToSurf_TurbFlux)
+            
 	    if (is_master) then
-             if (UseTurbDiff) then
-	       	print*,'In TurbDiff sensible flux (atm=>surf) =',AtmToSurf_TurbFlux,' W m-2'
-               	print*,'In TurbDiff non-cons atm nrj change   =',dEtot,' W m-2'
-               	print*,'In TurbDiff (correc rad+latent heat) surf nrj change =',dEtots,' W m-2'
-	     else
-	       	print*,'In vdifc sensible flux (atm=>surf)    =',AtmToSurf_TurbFlux,' W m-2'
-               	print*,'In vdifc non-cons atm nrj change      =',dEtot,' W m-2'
-               	print*,'In vdifc (correc rad+latent heat) surf nrj change =',dEtots,' W m-2'
-	     end if
-	    endif ! of if (is_master)
-! JL12 note that the black body radiative flux emitted by the surface has been updated by the implicit scheme
-!    but not given back elsewhere
-         endif
-         !-------------------------
-
-         !-------------------------
-         ! test water conservation
+            
+               if (UseTurbDiff) then
+	       	  print*,'In TurbDiff sensible flux (atm=>surf) =',AtmToSurf_TurbFlux,' W m-2'
+               	  print*,'In TurbDiff non-cons atm nrj change   =',dEtot,' W m-2'
+                  print*,'In TurbDiff (correc rad+latent heat) surf nrj change =',dEtots,' W m-2'
+	       else
+	       	  print*,'In vdifc sensible flux (atm=>surf)    =',AtmToSurf_TurbFlux,' W m-2'
+               	  print*,'In vdifc non-cons atm nrj change      =',dEtot,' W m-2'
+               	  print*,'In vdifc (correc rad+latent heat) surf nrj change =',dEtots,' W m-2'
+	       end if
+	    endif ! end of 'is_master'
+            
+         ! JL12 : note that the black body radiative flux emitted by the surface has been updated by the implicit scheme but not given back elsewhere.
+         endif ! end of 'enertest'
+
+
+         ! Test water conservation.
          if(watertest.and.water)then
+         
 	    call planetwide_sumval(massarea(:,:)*zdqdif(:,:,igcm_h2o_vap)*ptimestep/totarea_planet,dWtot_tmp)
 	    call planetwide_sumval(zdqsdif(:,igcm_h2o_vap)*area(:)*ptimestep/totarea_planet,dWtots_tmp)
             do ig = 1, ngrid
 	       vdifcncons(ig)=SUM(mass(ig,:)*zdqdif(ig,:,igcm_h2o_vap))
-	    Enddo
+	    enddo
 	    call planetwide_sumval(massarea(:,:)*zdqdif(:,:,igcm_h2o_ice)*ptimestep/totarea_planet,dWtot)
 	    call planetwide_sumval(zdqsdif(:,igcm_h2o_ice)*area(:)*ptimestep/totarea_planet,dWtots)
@@ -1123,19 +1071,19 @@
             do ig = 1, ngrid
 	       vdifcncons(ig)=vdifcncons(ig) + SUM(mass(ig,:)*zdqdif(ig,:,igcm_h2o_ice))
-	    Enddo	    
+	    enddo	    
 	    call planetwide_maxval(vdifcncons(:),nconsMAX)
 
 	    if (is_master) then
-            	print*,'---------------------------------------------------------------'
-            	print*,'In difv atmospheric water change        =',dWtot,' kg m-2'
-            	print*,'In difv surface water change            =',dWtots,' kg m-2'
-            	print*,'In difv non-cons factor                 =',dWtot+dWtots,' kg m-2'
-            	print*,'In difv MAX non-cons factor             =',nconsMAX,' kg m-2 s-1'
+               print*,'---------------------------------------------------------------'
+               print*,'In difv atmospheric water change        =',dWtot,' kg m-2'
+               print*,'In difv surface water change            =',dWtots,' kg m-2'
+               print*,'In difv non-cons factor                 =',dWtot+dWtots,' kg m-2'
+               print*,'In difv MAX non-cons factor             =',nconsMAX,' kg m-2 s-1'
 	    endif
 
-         endif
+         endif ! end of 'watertest'
          !-------------------------
 
-      else    
+      else ! calldifv
 
          if(.not.newtonian)then
@@ -1145,10 +1093,10 @@
          endif
 
-      endif ! of if (calldifv)
-
-
-!-----------------------------------------------------------------------
-!   5. Dry convective adjustment:
-!   -----------------------------
+      endif ! end of 'calldifv'
+
+
+!----------------------------------
+!   IV. Dry convective adjustment :
+!----------------------------------
 
       if(calladj) then
@@ -1160,10 +1108,10 @@
 
 
-         call convadj(ngrid,nlayer,nq,ptimestep,    &
-              pplay,pplev,zpopsk,                   &
-              pu,pv,zh,pq,                          &
-              pdu,pdv,zdh,pdq,                      &
-              zduadj,zdvadj,zdhadj,                 &
-              zdqadj)
+         call convadj(ngrid,nlayer,nq,ptimestep,            &
+                      pplay,pplev,zpopsk,                   &
+                      pu,pv,zh,pq,                          &
+                      pdu,pdv,zdh,pdq,                      &
+                      zduadj,zdvadj,zdhadj,                 &
+                      zdqadj)
 
          pdu(1:ngrid,1:nlayer) = pdu(1:ngrid,1:nlayer) + zduadj(1:ngrid,1:nlayer)
@@ -1176,50 +1124,48 @@
          end if
 
-         !-------------------------
-         ! test energy conservation
+         ! Test energy conservation
          if(enertest)then
 	    call planetwide_sumval(cpp*massarea(:,:)*zdtadj(:,:)/totarea_planet,dEtot)
             if (is_master) print*,'In convadj atmospheric energy change  =',dEtot,' W m-2'
          endif
-         !-------------------------
-
-         !-------------------------
-         ! test water conservation
+
+         ! Test water conservation
          if(watertest)then
 	    call planetwide_sumval(massarea(:,:)*zdqadj(:,:,igcm_h2o_vap)*ptimestep/totarea_planet,dWtot_tmp)
             do ig = 1, ngrid
 	       cadjncons(ig)=SUM(mass(ig,:)*zdqadj(ig,:,igcm_h2o_vap))
-	    Enddo
+	    enddo
 	    call planetwide_sumval(massarea(:,:)*zdqadj(:,:,igcm_h2o_ice)*ptimestep/totarea_planet,dWtot)
 	    dWtot = dWtot + dWtot_tmp
             do ig = 1, ngrid
 	       cadjncons(ig)=cadjncons(ig) + SUM(mass(ig,:)*zdqadj(ig,:,igcm_h2o_ice))
-	    Enddo	    
+	    enddo	    
 	    call planetwide_maxval(cadjncons(:),nconsMAX)
 
             if (is_master) then
-	    	print*,'In convadj atmospheric water change     =',dWtot,' kg m-2'
-            	print*,'In convadj MAX non-cons factor          =',nconsMAX,' kg m-2 s-1'
+	       print*,'In convadj atmospheric water change     =',dWtot,' kg m-2'
+               print*,'In convadj MAX non-cons factor          =',nconsMAX,' kg m-2 s-1'
 	    endif
-         endif
-         !-------------------------
+            
+         endif ! end of 'watertest'
          
-      endif ! of if(calladj)
-
-!-----------------------------------------------------------------------
-!   6. Carbon dioxide condensation-sublimation:
-!   -------------------------------------------
+      endif ! end of 'calladj'
+
+!-----------------------------------------------
+!   V. Carbon dioxide condensation-sublimation :
+!-----------------------------------------------
 
       if (co2cond) then
+      
          if (.not.tracer) then
             print*,'We need a CO2 ice tracer to condense CO2'
             call abort
          endif
-         call condense_cloud(ngrid,nlayer,nq,ptimestep,   &
-              capcal,pplay,pplev,tsurf,pt,                  &
-              pphi,pdt,pdu,pdv,zdtsurf,pu,pv,pq,pdq,        &
-              qsurf(1,igcm_co2_ice),albedo,emis,            &
-              zdtc,zdtsurfc,pdpsrf,zduc,zdvc,               &
-              zdqc)
+         call condense_co2(ngrid,nlayer,nq,ptimestep,                    &
+                           capcal,pplay,pplev,tsurf,pt,                  &
+                           pphi,pdt,pdu,pdv,zdtsurf,pu,pv,pq,pdq,        &
+                           qsurf(1,igcm_co2_ice),albedo,emis,            &
+                           zdtc,zdtsurfc,pdpsrf,zduc,zdvc,               &
+                           zdqc)
 
          pdt(1:ngrid,1:nlayer)=pdt(1:ngrid,1:nlayer)+zdtc(1:ngrid,1:nlayer)
@@ -1229,8 +1175,5 @@
 
          pdq(1:ngrid,1:nlayer,1:nq)=pdq(1:ngrid,1:nlayer,1:nq)+ zdqc(1:ngrid,1:nlayer,1:nq) 
-         ! Note: we do not add surface co2ice tendency
-         ! because qsurf(:,igcm_co2_ice) is updated in condens_co2cloud
-
-         !-------------------------
+
          ! test energy conservation
          if(enertest)then
@@ -1238,46 +1181,42 @@
 	    call planetwide_sumval(capcal(:)*zdtsurfc(:)*area(:)/totarea_planet,dEtots)
 	    if (is_master) then
-	    	print*,'In co2cloud atmospheric energy change   =',dEtot,' W m-2'
-            	print*,'In co2cloud surface energy change       =',dEtots,' W m-2'
+	       print*,'In co2cloud atmospheric energy change   =',dEtot,' W m-2'
+               print*,'In co2cloud surface energy change       =',dEtots,' W m-2'
 	    endif
          endif
-         !-------------------------
-
-      endif  ! of if (co2cond)
-
-
-!-----------------------------------------------------------------------
-!   7. Specific parameterizations for tracers 
-!   -----------------------------------------
-
-      if (tracer) then 
-
-!   7a. Water and ice
-!     ---------------
+
+      endif  ! end of 'co2cond'
+
+
+!---------------------------------------------
+!   VI. Specific parameterizations for tracers 
+!---------------------------------------------
+
+      if (tracer) then
+      
+  ! ---------------------
+  !   VI.1. Water and ice
+  ! ---------------------
          if (water) then
 
-!        ----------------------------------------
-!        Water ice condensation in the atmosphere
-!        ----------------------------------------
+            ! Water ice condensation in the atmosphere
             if(watercond.and.(RLVTT.gt.1.e-8))then
-
-!             ----------------
-!             Moist convection
-!             ----------------
 
 	       dqmoist(1:ngrid,1:nlayer,1:nq)=0.
 	       dtmoist(1:ngrid,1:nlayer)=0.
-
+               
+               ! Moist Convective Adjustment.
+               ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 	       call moistadj(ngrid,nlayer,nq,pt,pq,pdq,pplev,pplay,dtmoist,dqmoist,ptimestep,rneb_man)
 
-               pdq(1:ngrid,1:nlayer,igcm_h2o_vap) = pdq(1:ngrid,1:nlayer,igcm_h2o_vap)   &
-	                  +dqmoist(1:ngrid,1:nlayer,igcm_h2o_vap)
-               pdq(1:ngrid,1:nlayer,igcm_h2o_ice) =pdq(1:ngrid,1:nlayer,igcm_h2o_ice)     &
-                          +dqmoist(1:ngrid,1:nlayer,igcm_h2o_ice)
+               pdq(1:ngrid,1:nlayer,igcm_h2o_vap) = pdq(1:ngrid,1:nlayer,igcm_h2o_vap)     &
+	                                          + dqmoist(1:ngrid,1:nlayer,igcm_h2o_vap)
+               pdq(1:ngrid,1:nlayer,igcm_h2o_ice) = pdq(1:ngrid,1:nlayer,igcm_h2o_ice)     &
+                                                  + dqmoist(1:ngrid,1:nlayer,igcm_h2o_ice)
                pdt(1:ngrid,1:nlayer) = pdt(1:ngrid,1:nlayer)+dtmoist(1:ngrid,1:nlayer)
 
-               !-------------------------
-               ! test energy conservation
+               ! Test energy conservation.
                if(enertest)then
+               
 		  call planetwide_sumval(cpp*massarea(:,:)*dtmoist(:,:)/totarea_planet,dEtot)
 		  call planetwide_maxval(dtmoist(:,:),dtmoist_max)
@@ -1287,21 +1226,20 @@
                      madjdE(ig) = cpp*SUM(mass(:,:)*dtmoist(:,:))
                   enddo
+                  
 		  if (is_master) then
-                  	print*,'In moistadj atmospheric energy change   =',dEtot,' W m-2'
-                  	print*,'In moistadj MAX atmospheric energy change   =',dtmoist_max*ptimestep,'K/step'
-                  	print*,'In moistadj MIN atmospheric energy change   =',dtmoist_min*ptimestep,'K/step'
+                     print*,'In moistadj atmospheric energy change   =',dEtot,' W m-2'
+                     print*,'In moistadj MAX atmospheric energy change   =',dtmoist_max*ptimestep,'K/step'
+                     print*,'In moistadj MIN atmospheric energy change   =',dtmoist_min*ptimestep,'K/step'
 		  endif
 		  
-		! test energy conservation
 		  call planetwide_sumval(massarea(:,:)*dqmoist(:,:,igcm_h2o_vap)*ptimestep/totarea_planet+	&
-		  	massarea(:,:)*dqmoist(:,:,igcm_h2o_ice)*ptimestep/totarea_planet,dWtot)
+		  	                 massarea(:,:)*dqmoist(:,:,igcm_h2o_ice)*ptimestep/totarea_planet,dWtot)
 		  if (is_master) print*,'In moistadj atmospheric water change    =',dWtot,' kg m-2'
-               endif
-               !-------------------------
+                  
+               endif ! end of 'enertest'
 	       
 
-!        --------------------------------
-!        Large scale condensation/evaporation
-!        --------------------------------
+               ! Large scale condensation/evaporation.
+               ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                call largescale(ngrid,nlayer,nq,ptimestep,pplev,pplay,pt,pq,pdt,pdq,dtlscale,dqvaplscale,dqcldlscale,rneb_lsc)
 
@@ -1310,6 +1248,5 @@
                pdq(1:ngrid,1:nlayer,igcm_h2o_ice) = pdq(1:ngrid,1:nlayer,igcm_h2o_ice)+dqcldlscale(1:ngrid,1:nlayer)
 
-               !-------------------------
-               ! test energy conservation
+               ! Test energy conservation.
                if(enertest)then
                   lscaledEz(:,:) = cpp*mass(:,:)*dtlscale(:,:)
@@ -1318,18 +1255,15 @@
                   enddo
 		  call planetwide_sumval(cpp*massarea(:,:)*dtlscale(:,:)/totarea_planet,dEtot)
-!		  if(isnan(dEtot)) then ! NB: isnan() is not a standard function...
-!		     print*,'Nan in largescale, abort'
-!                     STOP
-!		  endif
+
 		  if (is_master) print*,'In largescale atmospheric energy change =',dEtot,' W m-2'
 
-               ! test water conservation
+                  ! Test water conservation.
 		  call planetwide_sumval(massarea(:,:)*dqvaplscale(:,:)*ptimestep/totarea_planet+	&
-		  	SUM(massarea(:,:)*dqcldlscale(:,:))*ptimestep/totarea_planet,dWtot)
+		  	                 SUM(massarea(:,:)*dqcldlscale(:,:))*ptimestep/totarea_planet,dWtot)
+                        
 		  if (is_master) print*,'In largescale atmospheric water change  =',dWtot,' kg m-2'
-               endif
-               !-------------------------
-
-               ! compute cloud fraction
+               endif ! end of 'enertest'
+
+               ! Compute cloud fraction.
                do l = 1, nlayer
                   do ig=1,ngrid
@@ -1338,10 +1272,8 @@
                enddo
 
-            endif                ! of if (watercondense)
+            endif ! end of 'watercond'
            
-
-!        --------------------------------
-!        Water ice / liquid precipitation
-!        --------------------------------
+            ! Water ice / liquid precipitation.
+            ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             if(waterrain)then
 
@@ -1351,18 +1283,18 @@
 
                call rain(ngrid,nlayer,nq,ptimestep,pplev,pplay,pt,pdt,pq,pdq,            &
-                   zdtrain,zdqrain,zdqsrain,zdqssnow,cloudfrac)
+                         zdtrain,zdqrain,zdqsrain,zdqssnow,cloudfrac)
 
                pdq(1:ngrid,1:nlayer,igcm_h2o_vap) = pdq(1:ngrid,1:nlayer,igcm_h2o_vap) &
-	             +zdqrain(1:ngrid,1:nlayer,igcm_h2o_vap)
+	                                          + zdqrain(1:ngrid,1:nlayer,igcm_h2o_vap)
                pdq(1:ngrid,1:nlayer,igcm_h2o_ice) = pdq(1:ngrid,1:nlayer,igcm_h2o_ice) &
-	             +zdqrain(1:ngrid,1:nlayer,igcm_h2o_ice)
+	                                          + zdqrain(1:ngrid,1:nlayer,igcm_h2o_ice)
                pdt(1:ngrid,1:nlayer) = pdt(1:ngrid,1:nlayer)+zdtrain(1:ngrid,1:nlayer)
-               dqsurf(1:ngrid,igcm_h2o_vap) = dqsurf(1:ngrid,igcm_h2o_vap)+zdqsrain(1:ngrid) ! a bug was here
-               dqsurf(1:ngrid,igcm_h2o_ice) = dqsurf(1:ngrid,igcm_h2o_ice)+zdqssnow(1:ngrid)
-               rainout(1:ngrid)             = zdqsrain(1:ngrid)+zdqssnow(1:ngrid) ! diagnostic   
-
-               !-------------------------
-               ! test energy conservation
+               
+               dqsurf(1:ngrid,igcm_h2o_vap) = dqsurf(1:ngrid,igcm_h2o_vap)+zdqsrain(1:ngrid)
+               dqsurf(1:ngrid,igcm_h2o_ice) = dqsurf(1:ngrid,igcm_h2o_ice)+zdqssnow(1:ngrid) 
+
+               ! Test energy conservation.
                if(enertest)then
+               
 		  call planetwide_sumval(cpp*massarea(:,:)*zdtrain(:,:)/totarea_planet,dEtot)
 		  if (is_master) print*,'In rain atmospheric T energy change       =',dEtot,' W m-2'
@@ -1374,14 +1306,16 @@
 		  dVtot = dVtot + dVtot_tmp
 		  dEtot = dItot + dVtot
+                  
 		  if (is_master) then
-                  	print*,'In rain dItot =',dItot,' W m-2'
-                  	print*,'In rain dVtot =',dVtot,' W m-2'
-                  	print*,'In rain atmospheric L energy change       =',dEtot,' W m-2'
+                     print*,'In rain dItot =',dItot,' W m-2'
+                     print*,'In rain dVtot =',dVtot,' W m-2'
+                     print*,'In rain atmospheric L energy change       =',dEtot,' W m-2'
 		  endif
 
-               ! test water conservation
+                  ! Test water conservation
 		  call planetwide_sumval(massarea(:,:)*zdqrain(:,:,igcm_h2o_vap)*ptimestep/totarea_planet+	&
 		  	massarea(:,:)*zdqrain(:,:,igcm_h2o_ice)*ptimestep/totarea_planet,dWtot)
 		  call planetwide_sumval((zdqsrain(:)+zdqssnow(:))*area(:)*ptimestep/totarea_planet,dWtots)
+                  
 		  if (is_master) then
                   	print*,'In rain atmospheric water change        =',dWtot,' kg m-2'
@@ -1389,82 +1323,72 @@
                   	print*,'In rain non-cons factor                 =',dWtot+dWtots,' kg m-2'
 		  endif
-              endif
-              !-------------------------
-
-            end if                 ! of if (waterrain)
-         end if                    ! of if (water)
-
-
-!   7c. Aerosol particles
-!     -------------------
-!        ------------- 
-!        Sedimentation
-!        ------------- 
-        if (sedimentation) then 
-           zdqsed(1:ngrid,1:nlayer,1:nq) = 0.0
-           zdqssed(1:ngrid,1:nq)  = 0.0
-
-
-           !-------------------------
-           ! find qtot
-           if(watertest)then
-              iq=igcm_h2o_ice
-	      call planetwide_sumval(massarea(:,:)*pq(:,:,iq)*ptimestep/totarea_planet,dWtot)
-	      call planetwide_sumval(massarea(:,:)*pdq(:,:,iq)*ptimestep/totarea_planet,dWtots)
-	      if (is_master) then
-	      	print*,'Before sedim pq  =',dWtot,' kg m-2'
-              	print*,'Before sedim pdq =',dWtots,' kg m-2'
-	      endif
-           endif
-           !-------------------------
-
-           call callsedim(ngrid,nlayer,ptimestep,           &
-                pplev,zzlev,pt,pdt,pq,pdq,zdqsed,zdqssed,nq)
-
-           !-------------------------
-           ! find qtot
-           if(watertest)then
-              iq=igcm_h2o_ice
-	      call planetwide_sumval(massarea(:,:)*pq(:,:,iq)*ptimestep/totarea_planet,dWtot)
-	      call planetwide_sumval(massarea(:,:)*pdq(:,:,iq)*ptimestep/totarea_planet,dWtots)
-	      if (is_master) then
-              	print*,'After sedim pq  =',dWtot,' kg m-2'
-              	print*,'After sedim pdq =',dWtots,' kg m-2'
-  	      endif
-           endif
-           !-------------------------
-
-           ! for now, we only allow H2O ice to sediment
-              ! and as in rain.F90, whether it falls as rain or snow depends
-              ! only on the surface temperature
-           pdq(1:ngrid,1:nlayer,1:nq) = pdq(1:ngrid,1:nlayer,1:nq) + zdqsed(1:ngrid,1:nlayer,1:nq)
-           dqsurf(1:ngrid,1:nq) = dqsurf(1:ngrid,1:nq) + zdqssed(1:ngrid,1:nq)
-
-           !-------------------------
-           ! test water conservation
-           if(watertest)then
-	      call planetwide_sumval(massarea(:,:)*(zdqsed(:,:,igcm_h2o_vap)+zdqsed(:,:,igcm_h2o_ice))*ptimestep/totarea_planet,dWtot)
-	      call planetwide_sumval((zdqssed(:,igcm_h2o_vap)+zdqssed(:,igcm_h2o_ice))*area(:)*ptimestep/totarea_planet,dWtots)
-	      if (is_master) then
-              	print*,'In sedim atmospheric ice change         =',dWtot,' kg m-2'
-              	print*,'In sedim surface ice change             =',dWtots,' kg m-2'
-              	print*,'In sedim non-cons factor                =',dWtot+dWtots,' kg m-2'
-	      endif
-           endif
-           !-------------------------
-
-        end if   ! of if (sedimentation)
-
-
-!   7d. Updates
-!     ---------
-
-!       -----------------------------------
-!       Updating atm mass and tracer budget
-!       -----------------------------------
-
+                  
+               endif ! end of 'enertest'
+
+            end if ! enf of 'waterrain'
+            
+         end if ! end of 'water'
+
+  ! -------------------------
+  !   VI.2. Aerosol particles
+  ! -------------------------
+
+         ! Sedimentation.
+         if (sedimentation) then
+        
+            zdqsed(1:ngrid,1:nlayer,1:nq) = 0.0
+            zdqssed(1:ngrid,1:nq)  = 0.0
+
+            if(watertest)then
+           
+               iq=igcm_h2o_ice
+	       call planetwide_sumval(massarea(:,:)*pq(:,:,iq)*ptimestep/totarea_planet,dWtot)
+	       call planetwide_sumval(massarea(:,:)*pdq(:,:,iq)*ptimestep/totarea_planet,dWtots)
+	       if (is_master) then
+	      	  print*,'Before sedim pq  =',dWtot,' kg m-2'
+                  print*,'Before sedim pdq =',dWtots,' kg m-2'
+	       endif
+            endif
+           
+            call callsedim(ngrid,nlayer,ptimestep,           &
+                          pplev,zzlev,pt,pdt,pq,pdq,        &
+                          zdqsed,zdqssed,nq)
+
+            if(watertest)then
+               iq=igcm_h2o_ice
+	       call planetwide_sumval(massarea(:,:)*pq(:,:,iq)*ptimestep/totarea_planet,dWtot)
+	       call planetwide_sumval(massarea(:,:)*pdq(:,:,iq)*ptimestep/totarea_planet,dWtots)
+	       if (is_master) then
+              	  print*,'After sedim pq  =',dWtot,' kg m-2'
+              	  print*,'After sedim pdq =',dWtots,' kg m-2'
+  	       endif
+            endif
+
+            ! Whether it falls as rain or snow depends only on the surface temperature
+            pdq(1:ngrid,1:nlayer,1:nq) = pdq(1:ngrid,1:nlayer,1:nq) + zdqsed(1:ngrid,1:nlayer,1:nq)
+            dqsurf(1:ngrid,1:nq) = dqsurf(1:ngrid,1:nq) + zdqssed(1:ngrid,1:nq)
+
+            ! Test water conservation
+            if(watertest)then
+	       call planetwide_sumval(massarea(:,:)*(zdqsed(:,:,igcm_h2o_vap)+zdqsed(:,:,igcm_h2o_ice))*ptimestep/totarea_planet,dWtot)
+	       call planetwide_sumval((zdqssed(:,igcm_h2o_vap)+zdqssed(:,igcm_h2o_ice))*area(:)*ptimestep/totarea_planet,dWtots)
+	       if (is_master) then
+              	  print*,'In sedim atmospheric ice change         =',dWtot,' kg m-2'
+              	  print*,'In sedim surface ice change             =',dWtots,' kg m-2'
+              	  print*,'In sedim non-cons factor                =',dWtot+dWtots,' kg m-2'
+	       endif
+            endif
+
+         end if ! end of 'sedimentation'
+
+
+  ! ---------------
+  !   VI.3. Updates
+  ! ---------------
+
+         ! Updating Atmospheric Mass and Tracers budgets.
          if(mass_redistrib) then
 
-            zdmassmr(1:ngrid,1:nlayer) = mass(1:ngrid,1:nlayer) * &
+            zdmassmr(1:ngrid,1:nlayer) = mass(1:ngrid,1:nlayer) *     &
 	       (   zdqevap(1:ngrid,1:nlayer)                          &
 	         + zdqrain(1:ngrid,1:nlayer,igcm_h2o_vap)             &
